/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package telas;

import Conection.BancoDados;
import ModeloControle.ControleAgenda;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Locale;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import modeloMetodos.Agenda;
import modeloMetodos.Tabela;

/**
 *
 * @author soare
 *  SimpleDateFormat formatado = new SimpleDateFormat("dd/MM/yyyy");
        String dataFormat = formatado.format(data);
        return dataFormat;
 */
public class FormAgenda extends javax.swing.JFrame {

     BancoDados conexao = new BancoDados();
     Agenda agenda = new Agenda();
      private Date data;
      Agenda agen = new Agenda();
     
      ControleAgenda controlagenda = new ControleAgenda();
      String dtHoje;
      String status;
     
    public FormAgenda() {
        initComponents();
       
        
        Calendar data = Calendar.getInstance();
        Date d = data.getTime(); // recebe data
      
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");
        dateFormat.format(d); //formata a data
       
        dtHoje= dateFormat.format(d);//data de hoje
        status = "Aberto"; // com os agendamentos em aberto
        
        
        preencherTabela("SELECT *from agenda inner join pacientes on agenda_codpac=cod_paciente inner join medico on agenda_codmedico=cod_medico where agenda_data='"+dtHoje+"' and agenda_status='"+status+"' order by agenda_turno");
    }
    
    public void preencherTabela(String Sql){
        ArrayList dados = new ArrayList();   
        String [] colunas = new String[]{"ID","Nome Paciente","Turno","Data","Status", "Medico","Especialidade"};
        conexao.conexao();
        conexao.executaSql(Sql);
        
        try{
            conexao.rs.first();
            do{
                dados.add(new Object[]{conexao.rs.getInt("cod_agenda"),conexao.rs.getString("pac_nome"),conexao.rs.getString("agenda_turno"),conexao.rs.getString("agenda_data"),conexao.rs.getString("agenda_status"),conexao.rs.getString("nome"),conexao.rs.getString("especialidade")});
                
                
            }while(conexao.rs.next()); //enquanto houver dados irá percorrer os dados
        
    }catch(SQLException ex){
            JOptionPane.showMessageDialog(rootPane, "Realizar Nova Busca");
           
            }
        Tabela modelo = new Tabela(dados, colunas);
        jTableAgenda.setModel(modelo);
        //coluna ID
        jTableAgenda.getColumnModel().getColumn(0).setPreferredWidth(40);//  tamanho da coluna
        jTableAgenda.getColumnModel().getColumn(0).setResizable(false); // não pode alterar tamanho da tabela
        //coluna nome paciente
        jTableAgenda.getColumnModel().getColumn(1).setPreferredWidth(200);//  tamanho da coluna
        jTableAgenda.getColumnModel().getColumn(1).setResizable(false); // não pode alterar tamanho da tabela        
        //coluna turno
        jTableAgenda.getColumnModel().getColumn(2).setPreferredWidth(100);//  tamanho da coluna
        jTableAgenda.getColumnModel().getColumn(2).setResizable(false); // não pode alterar tamanho da tabela   
        //coluna data
        jTableAgenda.getColumnModel().getColumn(3).setPreferredWidth(100);//  tamanho da coluna
        jTableAgenda.getColumnModel().getColumn(3).setResizable(false); // não pode alterar tamanho da tabela 
        //coluna status
        jTableAgenda.getColumnModel().getColumn(4).setPreferredWidth(100);//  tamanho da coluna
        jTableAgenda.getColumnModel().getColumn(4).setResizable(false); // não pode alterar tamanho da tabela  
        //coluna nome medico
        jTableAgenda.getColumnModel().getColumn(5).setPreferredWidth(160);//  tamanho da coluna
        jTableAgenda.getColumnModel().getColumn(5).setResizable(false); // não pode alterar tamanho da tabela   
        //coluna especialidade medico
        jTableAgenda.getColumnModel().getColumn(6).setPreferredWidth(120);//  tamanho da coluna
        jTableAgenda.getColumnModel().getColumn(6).setResizable(false); // não pode alterar tamanho da tabela 
        jTableAgenda.getTableHeader().setReorderingAllowed(false);// não pode reordenar
        jTableAgenda.setAutoResizeMode(jTableAgenda.AUTO_RESIZE_OFF);//não pode redimensionar
        jTableAgenda.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);//seleciona um item por vez
        conexao.desconecta();
        
    }        
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTableAgenda = new javax.swing.JTable();
        jLabel2 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jTableAgenda.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        jTableAgenda.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jTableAgendaMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(jTableAgenda);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        jLabel2.setText("Agenda do dia:");

        jButton1.setText("ATENDER AGENDAMENTO");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(74, 74, 74)
                        .addComponent(jLabel2))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(135, 135, 135)
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 593, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(29, 29, 29)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 835, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(20, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 361, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 44, Short.MAX_VALUE)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(48, 48, 48))
        );

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        jLabel1.setText("AGENDA");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(23, 23, 23)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(406, 406, 406)
                        .addComponent(jLabel1)))
                .addContainerGap(21, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addGap(6, 6, 6)
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        setSize(new java.awt.Dimension(946, 636));
        setLocationRelativeTo(null);
    }// </editor-fold>//GEN-END:initComponents

    private void jTableAgendaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jTableAgendaMouseClicked
         String agenda_cod ="" +jTableAgenda.getValueAt(jTableAgenda.getSelectedRow(),0); 
         
       conexao.conexao();
       conexao.executaSql("select *from agenda where cod_agenda ='"+ agenda_cod+"'");
        try {
         
             conexao.rs.first();
             agen.setStatus("Em atendimento");
             agen.setAgendaCod(conexao.rs.getInt("cod_agenda"));
         
        } catch (SQLException ex) {
           JOptionPane.showMessageDialog(null,"Erro ao selecionar os dados"+ ex);
        }
       
       
       conexao.desconecta();
        
        
    }//GEN-LAST:event_jTableAgendaMouseClicked

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        controlagenda.Alterar(agen);
        preencherTabela("SELECT *from agenda inner join pacientes on agenda_codpac=cod_paciente inner join medico on agenda_codmedico=cod_medico where agenda_data='"+dtHoje+"' and agenda_status='"+status+"' order by agenda_turno");
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FormAgenda.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FormAgenda.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FormAgenda.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FormAgenda.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FormAgenda().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTableAgenda;
    // End of variables declaration//GEN-END:variables

}
